#include <bits/errno-return.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <sys/syscall.h>
#include <unistd.h>

extern "C"
{
    int mkdir(const char* path, mode_t mode)
    {
        long rc = syscall(SYS_mkdir, path, mode);
        __errno_return(rc, int);
    }

    int mknod(const char* path, mode_t mode, dev_t dev)
    {
        long rc = syscall(SYS_mknod, path, mode, dev);
        __errno_return(rc, int);
    }

    int stat(const char* path, struct stat* st)
    {
        long rc = syscall(SYS_fstatat, AT_FDCWD, path, st, 0);
        __errno_return(rc, int);
    }

    int fstat(int fd, struct stat* st)
    {
        long rc = syscall(SYS_fstatat, fd, "", st, AT_EMPTY_PATH);
        __errno_return(rc, int);
    }
}
